//use a stack? put symbols [+-.,<>] on it? only problem seems to be the []'s, so if we store the current loop... hmmm wait, we could just push [32 on the stack since we have the array of symbols as a string... so when a ] is reached, just jump back to the last [ on the stack and do the bit test. Yes, this should work.

BF_ARRAY_LEN = 4000;

//alert(concat(new Array("abcd"),new Array(45,46,47)));

arr = new Array(BF_ARRAY_LEN);	// or however ya do this

function push(el, stack)
{
  stack[stack.length] = el;
  return stack;
}

function peek(stack)
{
  return stack[stack.length-1];
}

function pop(stack)
{
  return stack.slice(0,stack.length-2);
}

function evalBF(codestr, outputField)
{
  outputField.value = "";
  for (i=0; i<BF_ARRAY_LEN; i++) arr[i] = 0;
  ptr = 0;					// the index in the array
  loopstack = Array();
  i = 0;					// index in  code string

  while (i < codestr.length)
  {
	switch (codestr.charAt(i))
	{
	case "[":
	  if (arr[ptr]!=0) loopstack = push(i,loopstack);
	  else i = codestr.indexOf("]",i);
	  i++;
	  break;
	case "]":
	  i = peek(loopstack);
	  loopstack = pop(loopstack);
	  break;
	case "+":
	  arr[ptr]++;
	  i++;
	  break;
	case "-":
	  arr[ptr]--;
	  i++;
	  break;
	case "<":
	  ptr--;
	  i++;
	  break;
	case ">":
	  ptr++;
	  i++;
	  break;
	case ".":
	  outputField.value += String.fromCharCode(arr[ptr]);
	  i++;
	  break;
	case ",":
	  input = prompt("BF program input:","");
	  arr[ptr] = input.charCodeAt(0);
	  i++;
	  break;
	default:
	  i++;
	  break;
	}
  }
}

function strTimes(str,times)
{
  endstr = "";
  for (var i=0; i<times; i++) endstr += str;
  return endstr;
}

function printDifference(diff,poschar,negchar)
{
  str = "";
  if (diff>0)
	for (var b=0; b<diff; b++) str += poschar;
  else
	for (var b=0; b<-diff; b++) str += negchar;
  return str;
}

function writeBins(numBins,diff)
{
  str = strTimes("+",diff) + "[";

  for (var i=1; i<numBins; i++)
  {
	str += ">" + strTimes("+",i+1);
  }
  str += strTimes("<",numBins-1) + "-]";
  str += strTimes("+",diff);

  return str;
}

function findClosestBin(val,bins,currbin) // if dist is greater than the diff in currbin, stay put
{                                         // i.e. if there would be more >'s than +'s, just use +'s
  var minBin = 0;
  for (var b=1; b<bins.length; b++)
  {
	if (Math.abs(val-bins[b]) < Math.abs(val-bins[minBin])) minBin = b;
  }
  if (Math.abs(val-bins[minBin]) > Math.abs(val-bins[currbin])) return currbin;
  return minBin;
}

function text2BF(textstr, numBins)
{
  if (numBins<=0) return "error: too few bins";
  var bins = new Array(numBins);
  var diff = Math.floor(127/numBins);
  for (var i=0; i<numBins; i++) bins[i] = (i + 1) * diff;
  var codestr = writeBins(numBins,diff);
  var i = 0;
  var currbin = 0;
  var newbin = 0;

  while (i < textstr.length)
  {
	c = textstr.charCodeAt(i);
	newbin = findClosestBin(c,bins,currbin);
	codestr += printDifference(newbin-currbin,">","<");
	codestr += printDifference(c-bins[newbin],"+","-");
	codestr += ".";
	currbin = newbin;
	bins[newbin] = c;
	i++;
  }
  return codestr;
}

function smartText2BF(textstr, binField)
{
   var bestbin = 1;
   var results = new Array(16);
   var beststr = "";

   var resultstr = "";

   for (var i=1; i<=16; i++)
   {
	 var str = text2BF(textstr, i);
	 results[i-1] = str.length;
	 
	 if (results[i-1] < results[bestbin-1])
	 {
	   beststr = str;
	   bestbin = i;
	 }

	 resultstr += i + ": " + results[i-1] + "\n";
   }

   //   alert(resultstr + bestbin);

   binField.value = bestbin;
   return beststr;
}

// function quineGenerator()		// can't work since a str only gets longer with text2BF
// {
//   var bfchars = new Array("+","-",">","<","[","]",".",",");
//   var length = 1000;
//   var i = 0;
//   while (i<1000000)
//   {
// 	var codestr = "";
// 	for (var j=0; j<length; j++) codestr += bfchars[Math.random()%bfchars.length];
// 	if (text2BF(codestr,8)==codestr) return codestr;
// 	i++;
//   }
// }
